package exceptii;

public class AlreadyContainedException extends Exception {

	/**
	 * Numar unic de identificare - obiectele descendente din Exception sunt serializabile.
	 * 
	 * Obiectele serializabile permit o reprezentare portabila in memorie pentru a putea fi trimise si
	 * "despachetate" usor de catre alte masini virtuale Java (care pot rula chiar pe alte
	 * calculatoare, eventual cu arhitecturi diferite).
	 * 
	 * Serializabilitatea e o proprietate des folosita in aplicatii distribuite.
	 */
	private static final long serialVersionUID = -1428764862419151365L;

	
}
