package exceptii;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

public class Test {

	private static final int N_NUMBERS = 10;
	private static final int N_CAP = 10;
	
	public static void foo() {
		foo();
	}
	
	public static void bar() {
		int [] v = new int[Integer.MAX_VALUE];
		v[0] = 1;
	}
	
	public static void main(String [] arg) {
		// 1 - duplicate
		System.out.println("----- Ex 1: multime cu duplicate");
		MySet<String> superset = new MySet<String>();
		try {
			superset.addNew("gigi");
			superset.addNew("mara");
			superset.addNew("gigi");
		} catch (AlreadyContainedException e) {
			e.printStackTrace();
		}
		System.out.println(superset);
		
		// 2 - erori de sistem
		try {
			foo();
		} catch (StackOverflowError e) {
			System.out.println("stack overflow here!");
		}
		
		System.out.println("recovered from stack overflow");
		
		try {
			bar();
		} catch (OutOfMemoryError e ) {
			System.out.println("too much allocation");
			e.printStackTrace();
		}
		System.out.println("recovered from memory cap");
		
		// 3 - calculator;
		Calculator calc = new Calculator();
		
		try {
			System.out.println("Normal add: 1 + 2 = " + calc.add(1,2));
			System.out.println(calc.add(Integer.MAX_VALUE,2));
		} catch (Calculator.OverflowException e) {
			System.out.println("Underflow!");
			e.printStackTrace();
		}
		
		try {
			System.out.println(calc.add(Integer.MIN_VALUE,-2));
		} catch (Calculator.UnderflowException e) {
			System.out.println("Overflow!");
			e.printStackTrace();
		}
		
		try {
			System.out.println(calc.divide(1,0));
		} catch (Calculator.DivisionByZeroException e) {
			System.out.println("Division by 0!");
			e.printStackTrace();
		}
		
		List <Integer> myList = new ArrayList <Integer> ();
		Random r = new Random();
		for (int i = 0; i < N_NUMBERS; i ++)
			myList.add(r.nextInt(N_CAP));
		
		System.out.println(myList);
		System.out.println("Average is " + calc.average(myList));
		
		// 4 - finally no matter what
		try {
			String s = null;
			s.split(" ");
			return;
		} catch (Exception e) {
			System.err.println("Super NullPEx!");
			e.printStackTrace();
		} finally {
			System.out.println("Finally, no matter what! See you before you return");
		}
	}
}
